local last
local fi
local temp

local tarList = {
"player",
"pet",
"target",
"target-target",
"focus",
}

local textList = {
"c 1337",
"c/m 1337/9001",
"c % 1337 15%",
"c/m %  1337/9001 15%",
"% 15%",
}

local function Dimension(frame, w, h)
	frame:SetWidth(w or 512) frame:SetHeight(h or w or 512)
end

CreateFrame("Frame","hudconfigframe",UIParent)
hudconfigframe:SetFrameStrata("HIGH")
hudconfigframe:SetAllPoints()


local bg = hudconfigframe:CreateTexture(nil)
bg:SetAllPoints(UIParent)
bg:SetTexture(0,0,0,0.7)

UIFrameFadeIn(hudconfigframe, 0.5)

local function clickbut(self)
	last:SetAlpha(0.5)
	self:SetAlpha(1)
	last.frame:Hide()
	self.frame:Show()
	last = self
end

do -- config for blocks at the bottom ( range checks atm )

local botblock = CreateFrame("Button", nil, hudconfigframe)
 botblock:SetText("range checks");
 botblock:SetPoint("CENTER", -20, -190)
 botblock:SetNormalFontObject(GameFontHighlight)
 botblock:SetWidth(60)
 botblock:SetHeight(15)
 botblock:SetAlpha(0.5)
 last = botblock
 botblock:SetScript("OnMouseUp", clickbut)
 botblock.frame = CreateFrame("Frame",nil,hudconfigframe)
 botblock.frame:SetPoint("LEFT", 20, 0)
 botblock.frame:SetWidth(300)
 botblock.frame:SetHeight(500)
 botblock.frame:Hide()
 botblock.frame.elem1 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem1:SetPoint("TOPLEFT")
 botblock.frame.elem1:SetText("Left block")
 botblock.frame.elem2 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem2:SetPoint("TOPLEFT", 10, -30)
 botblock.frame.elem2:SetText("ability:")
 botblock.frame.elem3 = CreateFrame("EditBox", "botblockframeelem3", botblock.frame, "InputBoxTemplate")
 botblock.frame.elem3:SetPoint("LEFT", botblock.frame.elem2, "RIGHT", 10, 0)
 botblock.frame.elem3:SetAutoFocus(false)
 botblock.frame.elem3:SetText(hudoptions[hudpro].botblock[1])
 Dimension(botblock.frame.elem3, 120, 16)
 botblock.frame.elem3:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].botblock[1] = self:GetText()
	updateHud()
	self:ClearFocus()
 end)
 botblock.frame.elem4 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem4:SetPoint("TOPLEFT", 10, -65)
 botblock.frame.elem4:SetText("target:")
 botblock.frame.elem5 = CreateFrame("Frame", "botblock.frame.elem5", botblock.frame, "UIDropDownMenuTemplate")
 botblock.frame.elem5:SetPoint("LEFT", botblock.frame.elem4, "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(botblock.frame.elem5, function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = tarList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(botblock.frame.elem5, tarList[i]) hudoptions[hudpro].botblock[2] = tarList[i] updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(botblock.frame.elem5, hudoptions[hudpro].botblock[2])
 botblock.frame.elem6 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem6:SetPoint("TOPLEFT", 10, -90)
 botblock.frame.elem6:SetText("in range:")
 botblock.frame.elem7 = CreateFrame("Frame",nil,botblock.frame)
 botblock.frame.elem7:SetPoint("LEFT", botblock.frame.elem6, "RIGHT", 10, -1)
 botblock.frame.elem7:SetWidth(10)
 botblock.frame.elem7:SetHeight(10)
 botblockglob1 = botblock.frame.elem7:CreateTexture(nil)
 botblockglob1:SetAllPoints()
 botblockglob1:SetTexture(unpack(hudoptions[hudpro].botblock[3]))
 botblock.frame.elem7:EnableMouse(true)
 botblock.frame.elem7.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botblock[3][1] = r
	hudoptions[hudpro].botblock[3][2] = g
	hudoptions[hudpro].botblock[3][3] = b
	botblockglob1:SetTexture(r, g, b)
	updateHud()
 end
 botblock.frame.elem7.hasOpacity = 1
 botblock.frame.elem7.opacityFunc = function()
	hudoptions[hudpro].botblock[4] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botblock.frame.elem7:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botblock[4]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botblock[3])
 OpenColorPicker(self)
 end)
 botblock.frame.elem8 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem8:SetPoint("LEFT", botblockglob1, "RIGHT", 10, 1)
 botblock.frame.elem8:SetText("out of range:")
 botblock.frame.elem9 = CreateFrame("Frame",nil,botblock.frame)
 botblock.frame.elem9:SetPoint("LEFT", botblock.frame.elem8, "RIGHT", 10, -1)
 botblock.frame.elem9:SetWidth(10)
 botblock.frame.elem9:SetHeight(10)
 botblockglob2 = botblock.frame.elem9:CreateTexture(nil)
 botblockglob2:SetAllPoints()
 botblockglob2:SetTexture(unpack(hudoptions[hudpro].botblock[5]))
 botblock.frame.elem9:EnableMouse(true)
 botblock.frame.elem9.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botblock[5][1] = r
	hudoptions[hudpro].botblock[5][2] = g
	hudoptions[hudpro].botblock[5][3] = b
	botblockglob2:SetTexture(r, g, b)
	updateHud()
 end
 botblock.frame.elem9.hasOpacity = 1
 botblock.frame.elem9.opacityFunc = function()
	hudoptions[hudpro].botblock[6] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botblock.frame.elem9:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botblock[6]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botblock[5])
 OpenColorPicker(self)
 end)
 
 
 botblock.frame.elem10 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem10:SetPoint("TOPLEFT", 0, -120)
 botblock.frame.elem10:SetText("Middle block")
 botblock.frame.elem11 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem11:SetPoint("TOPLEFT", 10, -150)
 botblock.frame.elem11:SetText("ability:")
 botblock.frame.elem12 = CreateFrame("EditBox", "botblockframeelem12", botblock.frame, "InputBoxTemplate")
 botblock.frame.elem12:SetPoint("LEFT", botblock.frame.elem11, "RIGHT", 10, 0)
 botblock.frame.elem12:SetAutoFocus(false)
 botblock.frame.elem12:SetText(hudoptions[hudpro].botblock[7])
 Dimension(botblock.frame.elem12, 120, 16)
 botblock.frame.elem12:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].botblock[7] = self:GetText()
	updateHud()
	self:ClearFocus()
 end)
 botblock.frame.elem13 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem13:SetPoint("TOPLEFT", 10, -185)
 botblock.frame.elem13:SetText("target:")
 botblock.frame.elem14 = CreateFrame("Frame", "botblock.frame.elem14", botblock.frame, "UIDropDownMenuTemplate")
 botblock.frame.elem14:SetPoint("LEFT", botblock.frame.elem13, "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(botblock.frame.elem14, function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = tarList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(botblock.frame.elem14, tarList[i]) hudoptions[hudpro].botblock[8] = tarList[i] updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(botblock.frame.elem14, hudoptions[hudpro].botblock[8])
 botblock.frame.elem15 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem15:SetPoint("TOPLEFT", 10, -210)
 botblock.frame.elem15:SetText("in range:")
 botblock.frame.elem16 = CreateFrame("Frame",nil,botblock.frame)
 botblock.frame.elem16:SetPoint("LEFT", botblock.frame.elem15, "RIGHT", 10, -1)
 botblock.frame.elem16:SetWidth(10)
 botblock.frame.elem16:SetHeight(10)
 botblockglob3 = botblock.frame.elem16:CreateTexture(nil)
 botblockglob3:SetAllPoints()
 botblockglob3:SetTexture(unpack(hudoptions[hudpro].botblock[9]))
 botblock.frame.elem16:EnableMouse(true)
 botblock.frame.elem16.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botblock[9][1] = r
	hudoptions[hudpro].botblock[9][2] = g
	hudoptions[hudpro].botblock[9][3] = b
	botblockglob3:SetTexture(r, g, b)
	updateHud()
 end
 botblock.frame.elem16.hasOpacity = 1
 botblock.frame.elem16.opacityFunc = function()
	hudoptions[hudpro].botblock[10] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botblock.frame.elem16:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botblock[10]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botblock[9])
 OpenColorPicker(self)
 end)
 botblock.frame.elem17 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem17:SetPoint("LEFT", botblockglob3, "RIGHT", 10, 1)
 botblock.frame.elem17:SetText("out of range:")
 botblock.frame.elem18 = CreateFrame("Frame",nil,botblock.frame)
 botblock.frame.elem18:SetPoint("LEFT", botblock.frame.elem17, "RIGHT", 10, -1)
 botblock.frame.elem18:SetWidth(10)
 botblock.frame.elem18:SetHeight(10)
 botblockglob4 = botblock.frame.elem18:CreateTexture(nil)
 botblockglob4:SetAllPoints()
 botblockglob4:SetTexture(unpack(hudoptions[hudpro].botblock[11]))
 botblock.frame.elem18:EnableMouse(true)
 botblock.frame.elem18.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botblock[11][1] = r
	hudoptions[hudpro].botblock[11][2] = g
	hudoptions[hudpro].botblock[11][3] = b
	botblockglob4:SetTexture(r, g, b)
	updateHud()
 end
 botblock.frame.elem18.hasOpacity = 1
 botblock.frame.elem18.opacityFunc = function()
	hudoptions[hudpro].botblock[12] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botblock.frame.elem18:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botblock[12]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botblock[11])
 OpenColorPicker(self)
 end)
 
 botblock.frame.elem19 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem19:SetPoint("TOPLEFT", 0, -240)
 botblock.frame.elem19:SetText("Right block")
 botblock.frame.elem20 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem20:SetPoint("TOPLEFT", 10, -270)
 botblock.frame.elem20:SetText("ability:")
 botblock.frame.elem21 = CreateFrame("EditBox", "botblockframeelem21", botblock.frame, "InputBoxTemplate")
 botblock.frame.elem21:SetPoint("LEFT", botblock.frame.elem20, "RIGHT", 10, 0)
 botblock.frame.elem21:SetAutoFocus(false)
 botblock.frame.elem21:SetText(hudoptions[hudpro].botblock[13])
 Dimension(botblock.frame.elem21, 120, 16)
 botblock.frame.elem21:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].botblock[13] = self:GetText()
	updateHud()
	self:ClearFocus()
 end)
 botblock.frame.elem22 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem22:SetPoint("TOPLEFT", 10, -305)
 botblock.frame.elem22:SetText("target:")
 botblock.frame.elem23 = CreateFrame("Frame", "botblock.frame.elem23", botblock.frame, "UIDropDownMenuTemplate")
 botblock.frame.elem23:SetPoint("LEFT", botblock.frame.elem22, "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(botblock.frame.elem23, function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = tarList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(botblock.frame.elem23, tarList[i]) hudoptions[hudpro].botblock[14] = tarList[i] updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(botblock.frame.elem23, hudoptions[hudpro].botblock[14])
 botblock.frame.elem24 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem24:SetPoint("TOPLEFT", 10, -330)
 botblock.frame.elem24:SetText("in range:")
 botblock.frame.elem25 = CreateFrame("Frame",nil,botblock.frame)
 botblock.frame.elem25:SetPoint("LEFT", botblock.frame.elem24, "RIGHT", 10, -1)
 botblock.frame.elem25:SetWidth(10)
 botblock.frame.elem25:SetHeight(10)
 botblockglob5 = botblock.frame.elem25:CreateTexture(nil)
 botblockglob5:SetAllPoints()
 botblockglob5:SetTexture(unpack(hudoptions[hudpro].botblock[15]))
 botblock.frame.elem25:EnableMouse(true)
 botblock.frame.elem25.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botblock[15][1] = r
	hudoptions[hudpro].botblock[15][2] = g
	hudoptions[hudpro].botblock[15][3] = b
	botblockglob5:SetTexture(r, g, b)
	updateHud()
 end
 botblock.frame.elem25.hasOpacity = 1
 botblock.frame.elem25.opacityFunc = function()
	hudoptions[hudpro].botblock[16] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botblock.frame.elem25:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botblock[16]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botblock[15])
 OpenColorPicker(self)
 end)
 botblock.frame.elem26 = botblock.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botblock.frame.elem26:SetPoint("LEFT", botblockglob5, "RIGHT", 10, 1)
 botblock.frame.elem26:SetText("out of range:")
 botblock.frame.elem27 = CreateFrame("Frame",nil,botblock.frame)
 botblock.frame.elem27:SetPoint("LEFT", botblock.frame.elem26, "RIGHT", 10, -1)
 botblock.frame.elem27:SetWidth(10)
 botblock.frame.elem27:SetHeight(10)
 botblockglob6 = botblock.frame.elem27:CreateTexture(nil)
 botblockglob6:SetAllPoints()
 botblockglob6:SetTexture(unpack(hudoptions[hudpro].botblock[17]))
 botblock.frame.elem27:EnableMouse(true)
 botblock.frame.elem27.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botblock[17][1] = r
	hudoptions[hudpro].botblock[17][2] = g
	hudoptions[hudpro].botblock[17][3] = b
	botblockglob6:SetTexture(r, g, b)
	updateHud()
 end
 botblock.frame.elem27.hasOpacity = 1
 botblock.frame.elem27.opacityFunc = function()
	hudoptions[hudpro].botblock[18] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botblock.frame.elem27:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botblock[18]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botblock[17])
 OpenColorPicker(self)
 end)
 
end
 
do --bottom bar ( bufftracker )
 fi=1
 local botbar = CreateFrame("Button", nil, hudconfigframe)
 botbar:SetText("bottom bar");
 botbar:SetPoint("CENTER", 20, -170)
 botbar:SetNormalFontObject(GameFontHighlight)
 botbar:SetWidth(60)
 botbar:SetHeight(15)
 botbar:SetAlpha(0.5)
 botbar:SetScript("OnMouseUp", clickbut)
 botbar.frame = CreateFrame("Frame",nil,hudconfigframe)
 botbar.frame:SetPoint("LEFT", 20, 0)
 botbar.frame:SetWidth(300)
 botbar.frame:SetHeight(500)
 botbar.frame:Hide()
 botbar.frame[fi] = CreateFrame("Frame",nil,botbar.frame)
 botbar.frame[fi]:EnableMouse(true)
 botbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].botbar[1] then
		hudoptions[hudpro].botbar[1] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].botbar[1] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 botbar.frame[fi].string = botbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botbar.frame[fi].string:SetPoint("TOPLEFT")
 botbar.frame[fi].string:SetText("Bottom bar")
 botbar.frame[fi].string:SetAlpha(hudoptions[hudpro].botbar[1] and 1 or 0.3)
 botbar.frame[fi]:SetAllPoints(botbar.frame[fi].string)
 fi=fi+1
 botbar.frame[fi] = botbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botbar.frame[fi]:SetPoint("TOPLEFT", 10, -30)
 botbar.frame[fi]:SetText("buff/debuff:")
 fi=fi+1
 botbar.frame[fi] = CreateFrame("EditBox", "botbarframeelem3", botbar.frame, "InputBoxTemplate")
 botbar.frame[fi]:SetPoint("LEFT", botbar.frame[fi-1], "RIGHT", 10, 0)
 botbar.frame[fi]:SetAutoFocus(false)
 botbar.frame[fi]:SetText(hudoptions[hudpro].botbar[2])
 Dimension(botbar.frame[fi], 120, 16)
 botbar.frame[fi]:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].botbar[2] = self:GetText()
	updateHud()
	self:ClearFocus()
 end)
 fi=fi+1
 botbar.frame[fi] = botbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botbar.frame[fi]:SetPoint("TOPLEFT", 10, -65)
 botbar.frame[fi]:SetText("target:")
 fi=fi+1
 botbar.frame[fi] = CreateFrame("Frame", "hudbotbarframedrop", botbar.frame, "UIDropDownMenuTemplate")
 botbar.frame[fi]:SetPoint("LEFT", botbar.frame[fi-1], "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(botbar.frame[fi], function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = tarList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(hudbotbarframedrop, tarList[i]) hudoptions[hudpro].botbar[3] = tarList[i] updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(botbar.frame[fi], hudoptions[hudpro].botbar[3])
 fi=fi+1
 botbar.frame[fi] = botbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botbar.frame[fi]:SetPoint("TOPLEFT", 10, -90)
 botbar.frame[fi]:SetText("color:")
 fi=fi+1
 botbar.frame[fi] = CreateFrame("Frame",nil,botbar.frame)
 botbar.frame[fi]:SetPoint("LEFT", botbar.frame[fi-1], "RIGHT", 10, -1)
 botbar.frame[fi]:SetWidth(10)
 botbar.frame[fi]:SetHeight(10)
 botbarglob1 = botbar.frame[fi]:CreateTexture(nil)
 botbarglob1:SetAllPoints()
 botbarglob1:SetTexture(unpack(hudoptions[hudpro].botbar[4]))
 botbar.frame[fi]:EnableMouse(true)
 botbar.frame[fi].swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].botbar[4][1] = r
	hudoptions[hudpro].botbar[4][2] = g
	hudoptions[hudpro].botbar[4][3] = b
	botbarglob1:SetTexture(r, g, b)
	updateHud()
 end
 botbar.frame[fi].hasOpacity = 1
 botbar.frame[fi].opacityFunc = function()
	hudoptions[hudpro].botbar[5] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 botbar.frame[fi]:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].botbar[5]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].botbar[4])
 OpenColorPicker(self)
 end)
 fi=fi+1
 botbar.frame[fi] = CreateFrame("Frame",nil,botbar.frame)
 botbar.frame[fi]:EnableMouse(true)
 botbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].botbar[6] then
		hudoptions[hudpro].botbar[6] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].botbar[6] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 botbar.frame[fi].string = botbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botbar.frame[fi].string:SetPoint("TOPLEFT", 20, -110)
 botbar.frame[fi].string:SetText("invert")
 botbar.frame[fi].string:SetAlpha(hudoptions[hudpro].botbar[6] and 1 or 0.3)
 botbar.frame[fi]:SetAllPoints(botbar.frame[fi].string)
 fi=fi+1
 botbar.frame[fi] = CreateFrame("Frame",nil,botbar.frame)
 botbar.frame[fi]:EnableMouse(true)
 botbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].botbar[7] then
		hudoptions[hudpro].botbar[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].botbar[7] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 botbar.frame[fi].string = botbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 botbar.frame[fi].string:SetPoint("TOPLEFT", 20, -130)
 botbar.frame[fi].string:SetText("by player only")
 botbar.frame[fi].string:SetAlpha(hudoptions[hudpro].botbar[7] and 1 or 0.3)
 botbar.frame[fi]:SetAllPoints(botbar.frame[fi].string)
 
end
 
do -- healthbar config
 
 local health = CreateFrame("Button", nil, hudconfigframe)
 health:SetText("health bar");
 health:SetPoint("CENTER", -150, -120)
 health:SetNormalFontObject(GameFontHighlight)
 health:SetWidth(60)
 health:SetHeight(15)
 health:SetAlpha(0.5)
 health:SetScript("OnMouseUp", clickbut)
 health.frame = CreateFrame("Frame",nil,hudconfigframe)
 health.frame:SetPoint("LEFT", 20, 0)
 health.frame:SetWidth(300)
 health.frame:SetHeight(500)
 health.frame:Hide()
 health.frame.elem1 = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem1:SetPoint("TOPLEFT")
 health.frame.elem1:SetText("health bar")
 health.frame.elem2 = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem2:SetPoint("TOPLEFT", 10, -30)
 health.frame.elem2:SetText("alpha:")
 health.frame.elem3 = CreateFrame("Slider", "healthframeelem3", health.frame, "OptionsSliderTemplate")
 health.frame.elem3:SetPoint("TOPLEFT", 10, -43)
 health.frame.elem3:SetWidth(100)
 health.frame.elem3:SetMinMaxValues(0, 20)
 health.frame.elem3:SetValue(hudoptions[hudpro].health[1]*20)
 healthframeelem3High:SetText(1)
 healthframeelem3Low:SetText(0)
 healthframeelem3Text:SetText(hudoptions[hudpro].health[1])
 health.frame.elem3:SetValueStep(1)
 health.frame.elem3:SetScript("OnMouseUp", function(self)
	self:SetScript("OnUpdate", nil)
	temp = (self:GetValue()/20)
	hudoptions[hudpro].health[1] = temp
	updateHud()
 end)
 health.frame.elem3:SetScript("OnMouseDown", function(self)
	self:SetScript("OnUpdate", function()
		healthframeelem3Text:SetText(self:GetValue()/20)
	end)	
 end)
 health.frame.elem4 = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem4:SetPoint("TOPLEFT", 10, -70)
 health.frame.elem4:SetText("color:")
 health.frame.elem5 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem5:SetPoint("LEFT", health.frame.elem4, "RIGHT", 10, -1)
 health.frame.elem5:SetWidth(10)
 health.frame.elem5:SetHeight(10)
 healthglob1 = health.frame.elem5:CreateTexture(nil)
 healthglob1:SetAllPoints()
 healthglob1:SetTexture(unpack(hudoptions[hudpro].health[2]))
 health.frame.elem5:EnableMouse(true)
 health.frame.elem5.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].health[2][1] = r
	hudoptions[hudpro].health[2][2] = g
	hudoptions[hudpro].health[2][3] = b
	healthglob1:SetTexture(r, g, b)
	updateHud()
 end
 health.frame.elem5:SetScript("OnMouseUp", function(self)
 ColorPickerFrame:ClearAllPoints()
 ColorPickerFrame:SetPoint("TOP", UIParent)
 self.r, self.g, self.b = unpack(hudoptions[hudpro].health[2])
 OpenColorPicker(self)
 end)
 health.frame.elem6 = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem6:SetPoint("TOPLEFT", 10, -90)
 health.frame.elem6:SetText("OnShow")
 health.frame.elem7 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem7:EnableMouse(true)
 health.frame.elem7:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[3] then
		hudoptions[hudpro].health[3] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[3] = true
		self.string:SetAlpha(1)
	end
 end)
 health.frame.elem7.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem7.string:SetPoint("TOPLEFT", 20, -110)
 health.frame.elem7.string:SetText("scale")
 health.frame.elem7.string:SetAlpha(hudoptions[hudpro].health[3] and 1 or 0.3)
 health.frame.elem7:SetAllPoints(health.frame.elem7.string)
 health.frame.elem8 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem8:EnableMouse(true)
 health.frame.elem8:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[4] then
		hudoptions[hudpro].health[4] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[4] = true
		self.string:SetAlpha(1)
	end
 end)
 health.frame.elem8.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem8.string:SetPoint("TOPLEFT", 20, -130)
 health.frame.elem8.string:SetText("rotate")
 health.frame.elem8.string:SetAlpha(hudoptions[hudpro].health[4] and 1 or 0.3)
 health.frame.elem8:SetAllPoints(health.frame.elem8.string)
 health.frame.elem9 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem9:EnableMouse(true)
 health.frame.elem9:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[5] then
		hudoptions[hudpro].health[5] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[5] = true
		self.string:SetAlpha(1)
	end
 end)
 health.frame.elem9.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem9.string:SetPoint("TOPLEFT", 20, -150)
 health.frame.elem9.string:SetText("fade")
 health.frame.elem9.string:SetAlpha(hudoptions[hudpro].health[5] and 1 or 0.3)
 health.frame.elem9:SetAllPoints(health.frame.elem9.string)
 
 health.frame.elem10 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem10:EnableMouse(true)
 health.frame.elem10:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[6] then
		hudoptions[hudpro].health[6] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[6] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 health.frame.elem10.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem10.string:SetPoint("TOPLEFT", 20, -200)
 health.frame.elem10.string:SetText("scale")
 health.frame.elem10.string:SetAlpha(hudoptions[hudpro].health[6] and 1 or 0.3)
 health.frame.elem10:SetAllPoints(health.frame.elem10.string)
 health.frame.elem11 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem11:EnableMouse(true)
 health.frame.elem11:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[7] then
		hudoptions[hudpro].health[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[7] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 health.frame.elem11.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem11.string:SetPoint("TOPLEFT", 20, -220)
 health.frame.elem11.string:SetText("rotate")
 health.frame.elem11.string:SetAlpha(hudoptions[hudpro].health[7] and 1 or 0.3)
 health.frame.elem11:SetAllPoints(health.frame.elem11.string)
 health.frame.elem12 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem12:EnableMouse(true)
 health.frame.elem12:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[8] then
		hudoptions[hudpro].health[8] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[8] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 health.frame.elem12.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem12.string:SetPoint("TOPLEFT", 20, -240)
 health.frame.elem12.string:SetText("fade")
 health.frame.elem12.string:SetAlpha(hudoptions[hudpro].health[8] and 1 or 0.3)
 health.frame.elem12:SetAllPoints(health.frame.elem12.string)
 health.frame.elem13 = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem13:SetPoint("TOPLEFT", 10, -180)
 health.frame.elem13:SetText("OnHide")
 
 health.frame.elem14 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem14:EnableMouse(true)
 health.frame.elem14:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[9] then
		hudoptions[hudpro].health[9] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[9] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 health.frame.elem14.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem14.string:SetPoint("TOPLEFT", 0, -270)
 health.frame.elem14.string:SetText("health text")
 health.frame.elem14.string:SetAlpha(hudoptions[hudpro].health[9] and 1 or 0.3)
 health.frame.elem14:SetAllPoints(health.frame.elem14.string)
 health.frame.elem15 = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem15:SetPoint("TOPLEFT", 10, -300)
 health.frame.elem15:SetText("style:")
 health.frame.elem16 = CreateFrame("Frame", "health.frame.elem16", health.frame, "UIDropDownMenuTemplate")
 health.frame.elem16:SetPoint("LEFT", health.frame.elem15, "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(health.frame.elem16, function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = textList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(health.frame.elem16, textList[i]) hudoptions[hudpro].health[10] = option[i].value updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(health.frame.elem16, textList[hudoptions[hudpro].health[10]])
 health.frame.elem17 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem17:EnableMouse(true)
 health.frame.elem17:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[11] then
		hudoptions[hudpro].health[11] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[11] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 health.frame.elem17.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem17.string:SetPoint("TOPLEFT", 10, -330)
 health.frame.elem17.string:SetText("hide when full")
 health.frame.elem17.string:SetAlpha(hudoptions[hudpro].health[11] and 1 or 0.3)
 health.frame.elem17:SetAllPoints(health.frame.elem17.string)
 health.frame.elem18 = CreateFrame("Frame",nil,health.frame)
 health.frame.elem18:EnableMouse(true)
 health.frame.elem18:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].health[12] then
		hudoptions[hudpro].health[12] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].health[12] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 health.frame.elem18.string = health.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 health.frame.elem18.string:SetPoint("LEFT", health.frame.elem5, "RIGHT", 10, 0)
 health.frame.elem18.string:SetText("sweep(bugged)")
 health.frame.elem18.string:SetAlpha(hudoptions[hudpro].health[12] and 1 or 0.3)
 health.frame.elem18:SetAllPoints(health.frame.elem18.string)
end

do -- left bar ( auracheck atm )

 fi=1
 local leftbar = CreateFrame("Button", nil, hudconfigframe)
 leftbar:SetText("left bar");
 leftbar:SetPoint("CENTER", -200, 0)
 leftbar:SetNormalFontObject(GameFontHighlight)
 leftbar:SetWidth(60)
 leftbar:SetHeight(15)
 leftbar:SetAlpha(0.5)
 leftbar:SetScript("OnMouseUp", clickbut)
 leftbar.frame = CreateFrame("Frame",nil,hudconfigframe)
 leftbar.frame:SetPoint("LEFT", 20, 0)
 leftbar.frame:SetWidth(300)
 leftbar.frame:SetHeight(500)
 leftbar.frame:Hide()
 leftbar.frame[fi] = CreateFrame("Frame",nil,leftbar.frame)
 leftbar.frame[fi]:EnableMouse(true)
 leftbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].leftbar[1] then
		hudoptions[hudpro].leftbar[1] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].leftbar[1] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 leftbar.frame[fi].string = leftbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 leftbar.frame[fi].string:SetPoint("TOPLEFT")
 leftbar.frame[fi].string:SetText("Left bar")
 leftbar.frame[fi].string:SetAlpha(hudoptions[hudpro].leftbar[1] and 1 or 0.3)
 leftbar.frame[fi]:SetAllPoints(leftbar.frame[fi].string)
 fi=fi+1
 leftbar.frame[fi] = leftbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 leftbar.frame[fi]:SetPoint("TOPLEFT", 10, -30)
 leftbar.frame[fi]:SetText("buff/debuff:")
 fi=fi+1
 leftbar.frame[fi] = CreateFrame("EditBox", "leftbarframeelem3", leftbar.frame, "InputBoxTemplate")
 leftbar.frame[fi]:SetPoint("LEFT", leftbar.frame[fi-1], "RIGHT", 10, 0)
 leftbar.frame[fi]:SetAutoFocus(false)
 leftbar.frame[fi]:SetText(hudoptions[hudpro].leftbar[2])
 Dimension(leftbar.frame[fi], 120, 16)
 leftbar.frame[fi]:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].leftbar[2] = self:GetText()
	updateHud()
	self:ClearFocus()
 end)
 fi=fi+1
 leftbar.frame[fi] = leftbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 leftbar.frame[fi]:SetPoint("TOPLEFT", 10, -65)
 leftbar.frame[fi]:SetText("target:")
 fi=fi+1
 leftbar.frame[fi] = CreateFrame("Frame", "hudleftbarframedrop", leftbar.frame, "UIDropDownMenuTemplate")
 leftbar.frame[fi]:SetPoint("LEFT", leftbar.frame[fi-1], "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(leftbar.frame[fi], function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = tarList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(hudleftbarframedrop, tarList[i]) hudoptions[hudpro].leftbar[3] = tarList[i] updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(leftbar.frame[fi], hudoptions[hudpro].leftbar[3])
 fi=fi+1
 leftbar.frame[fi] = leftbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 leftbar.frame[fi]:SetPoint("TOPLEFT", 10, -90)
 leftbar.frame[fi]:SetText("color:")
 fi=fi+1
 leftbar.frame[fi] = CreateFrame("Frame",nil,leftbar.frame)
 leftbar.frame[fi]:SetPoint("LEFT", leftbar.frame[fi-1], "RIGHT", 10, -1)
 leftbar.frame[fi]:SetWidth(10)
 leftbar.frame[fi]:SetHeight(10)
 leftbarglob1 = leftbar.frame[fi]:CreateTexture(nil)
 leftbarglob1:SetAllPoints()
 leftbarglob1:SetTexture(unpack(hudoptions[hudpro].leftbar[4]))
 leftbar.frame[fi]:EnableMouse(true)
 leftbar.frame[fi].swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].leftbar[4][1] = r
	hudoptions[hudpro].leftbar[4][2] = g
	hudoptions[hudpro].leftbar[4][3] = b
	leftbarglob1:SetTexture(r, g, b)
	updateHud()
 end
 leftbar.frame[fi].hasOpacity = 1
 leftbar.frame[fi].opacityFunc = function()
	hudoptions[hudpro].leftbar[5] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 leftbar.frame[fi]:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].leftbar[5]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].leftbar[4])
 OpenColorPicker(self)
 end)
 fi=fi+1
 leftbar.frame[fi] = CreateFrame("Frame",nil,leftbar.frame)
 leftbar.frame[fi]:EnableMouse(true)
 leftbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].leftbar[6] then
		hudoptions[hudpro].leftbar[6] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].leftbar[6] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 leftbar.frame[fi].string = leftbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 leftbar.frame[fi].string:SetPoint("TOPLEFT", 20, -110)
 leftbar.frame[fi].string:SetText("invert")
 leftbar.frame[fi].string:SetAlpha(hudoptions[hudpro].leftbar[6] and 1 or 0.3)
 leftbar.frame[fi]:SetAllPoints(leftbar.frame[fi].string)
 fi=fi+1
 leftbar.frame[fi] = CreateFrame("Frame",nil,leftbar.frame)
 leftbar.frame[fi]:EnableMouse(true)
 leftbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].leftbar[7] then
		hudoptions[hudpro].leftbar[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].leftbar[7] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 leftbar.frame[fi].string = leftbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 leftbar.frame[fi].string:SetPoint("TOPLEFT", 20, -130)
 leftbar.frame[fi].string:SetText("by player only")
 leftbar.frame[fi].string:SetAlpha(hudoptions[hudpro].leftbar[7] and 1 or 0.3)
 leftbar.frame[fi]:SetAllPoints(leftbar.frame[fi].string)
 
end
 
 local leftblock = CreateFrame("Button", nil, hudconfigframe)
 leftblock:SetText("left block");
 leftblock:SetPoint("CENTER", -70, 70)
 leftblock:SetNormalFontObject(GameFontHighlight)
 leftblock:SetWidth(60)
 leftblock:SetHeight(15)
 leftblock:SetAlpha(0.5)
 leftblock:SetScript("OnMouseUp", clickbut)
 leftblock.frame = CreateFrame("Frame",nil,hudconfigframe)
 leftblock.frame:SetPoint("LEFT", 20, 0)
 leftblock.frame:SetWidth(300)
 leftblock.frame:SetHeight(500)
 leftblock.frame:Hide()
 

do --buffs/debuffs 
 
 fi=1
 local buff = CreateFrame("Button", nil, hudconfigframe)
 buff:SetText("buffs/debuffs");
 buff:SetPoint("CENTER", -220, 100)
 buff:SetNormalFontObject(GameFontHighlight)
 buff:SetWidth(60)
 buff:SetHeight(15)
 buff:SetAlpha(0.5)
 buff:SetScript("OnMouseUp", clickbut)
 buff.frame = CreateFrame("Frame",nil,hudconfigframe)
 buff.frame:SetPoint("LEFT", 20, 0)
 buff.frame:SetWidth(300)
 buff.frame:SetHeight(500)
 buff.frame:Hide()
 buff.frame[fi] = CreateFrame("Frame",nil,buff.frame)
 buff.frame[fi]:EnableMouse(true)
 buff.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].buff[1] then
		hudoptions[hudpro].buff[1] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].buff[1] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 buff.frame[fi].string = buff.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 buff.frame[fi].string:SetPoint("TOPLEFT")
 buff.frame[fi].string:SetText("Buffs")
 buff.frame[fi].string:SetAlpha(hudoptions[hudpro].buff[1] and 1 or 0.3)
 buff.frame[fi]:SetAllPoints(buff.frame[fi].string)
 fi=fi+1
 buff.frame[fi] = CreateFrame("Frame",nil,buff.frame)
 buff.frame[fi]:EnableMouse(true)
 buff.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].buff[2] then
		hudoptions[hudpro].buff[2] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].buff[2] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 buff.frame[fi].string = buff.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 buff.frame[fi].string:SetPoint("TOPLEFT", 0, -15)
 buff.frame[fi].string:SetText("Debuffs")
 buff.frame[fi].string:SetAlpha(hudoptions[hudpro].buff[2] and 1 or 0.3)
 buff.frame[fi]:SetAllPoints(buff.frame[fi].string)
 fi=fi+1
end


do --target config
 fi=1
 local target = CreateFrame("Button", nil, hudconfigframe)
 target:SetText("target");
 target:SetPoint("CENTER", 0, 180)
 target:SetNormalFontObject(GameFontHighlight)
 target:SetWidth(60)
 target:SetHeight(15)
 target:SetAlpha(0.5)
 target:SetScript("OnMouseUp", clickbut)
 target.frame = CreateFrame("Frame",nil,hudconfigframe)
 target.frame:SetPoint("LEFT", 20, 0)
 target.frame:SetWidth(300)
 target.frame:SetHeight(500)
 target.frame:Hide()
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT")
 target.frame[fi]:SetText("target health bar")
 fi=fi+1
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -30)
 target.frame[fi]:SetText("alpha:")
 fi=fi+1
 target.frame[fi] = CreateFrame("Slider", "targetframeslider", target.frame, "OptionsSliderTemplate")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -43)
 target.frame[fi]:SetWidth(100)
 target.frame[fi]:SetMinMaxValues(0, 20)
 target.frame[fi]:SetValue(hudoptions[hudpro].target[1]*20)
 targetframesliderHigh:SetText(1)
 targetframesliderLow:SetText(0)
 targetframesliderText:SetText(hudoptions[hudpro].target[1])
 target.frame[fi]:SetValueStep(1)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	self:SetScript("OnUpdate", nil)
	temp = (self:GetValue()/20)
	hudoptions[hudpro].target[1] = temp
	updateHud()
 end)
 target.frame[fi]:SetScript("OnMouseDown", function(self)
	self:SetScript("OnUpdate", function()
		targetframesliderText:SetText(self:GetValue()/20)
	end)	
 end)
 fi=fi+1
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -70)
 target.frame[fi]:SetText("color:")
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:SetPoint("LEFT", target.frame[fi-1], "RIGHT", 10, -1)
 target.frame[fi]:SetWidth(10)
 target.frame[fi]:SetHeight(10)
 targetglob1 = target.frame[fi]:CreateTexture(nil)
 targetglob1:SetAllPoints()
 targetglob1:SetTexture(unpack(hudoptions[hudpro].target[2]))
 target.frame[fi]:EnableMouse(true)
 target.frame[fi].swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].target[2][1] = r
	hudoptions[hudpro].target[2][2] = g
	hudoptions[hudpro].target[2][3] = b
	targetglob1:SetTexture(r, g, b)
	updateHud()
 end
 target.frame[fi]:SetScript("OnMouseUp", function(self)
 ColorPickerFrame:ClearAllPoints()
 ColorPickerFrame:SetPoint("TOP", UIParent)
 self.r, self.g, self.b = unpack(hudoptions[hudpro].target[2])
 OpenColorPicker(self)
 end)
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:EnableMouse(true)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].target[3] then
		hudoptions[hudpro].target[3] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].target[3] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 target.frame[fi].string = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi].string:SetPoint("TOPLEFT", 10, -90)
 target.frame[fi].string:SetText("class color")
 target.frame[fi].string:SetAlpha(hudoptions[hudpro].target[3] and 1 or 0.3)
 target.frame[fi]:SetAllPoints(target.frame[fi].string)
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:EnableMouse(true)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].target[4] then
		hudoptions[hudpro].target[4] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].target[4] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 target.frame[fi].string = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi].string:SetPoint("TOPLEFT", 10, -110)
 target.frame[fi].string:SetText("hostility color")
 target.frame[fi].string:SetAlpha(hudoptions[hudpro].target[4] and 1 or 0.3)
 target.frame[fi]:SetAllPoints(target.frame[fi].string)
 fi=fi+1
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT", 0, -140)
 target.frame[fi]:SetText("target power bar")
 fi=fi+1
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -160)
 target.frame[fi]:SetText("alpha:")
 fi=fi+1
 target.frame[fi] = CreateFrame("Slider", "targetframeslider2", target.frame, "OptionsSliderTemplate")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -173)
 target.frame[fi]:SetWidth(100)
 target.frame[fi]:SetMinMaxValues(0, 20)
 target.frame[fi]:SetValue(hudoptions[hudpro].target[5]*20)
 targetframeslider2High:SetText(1)
 targetframeslider2Low:SetText(0)
 targetframeslider2Text:SetText(hudoptions[hudpro].target[5])
 target.frame[fi]:SetValueStep(1)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	self:SetScript("OnUpdate", nil)
	temp = (self:GetValue()/20)
	hudoptions[hudpro].target[5] = temp
	updateHud()
 end)
 target.frame[fi]:SetScript("OnMouseDown", function(self)
	self:SetScript("OnUpdate", function()
		targetframeslider2Text:SetText(self:GetValue()/20)
	end)	
 end)
 fi=fi+1
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -200)
 target.frame[fi]:SetText("color:")
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:SetPoint("LEFT", target.frame[fi-1], "RIGHT", 10, -1)
 target.frame[fi]:SetWidth(10)
 target.frame[fi]:SetHeight(10)
 targetglob2 = target.frame[fi]:CreateTexture(nil)
 targetglob2:SetAllPoints()
 targetglob2:SetTexture(unpack(hudoptions[hudpro].target[6]))
 target.frame[fi]:EnableMouse(true)
 target.frame[fi].swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].target[6][1] = r
	hudoptions[hudpro].target[6][2] = g
	hudoptions[hudpro].target[6][3] = b
	targetglob2:SetTexture(r, g, b)
	updateHud()
 end
 target.frame[fi]:SetScript("OnMouseUp", function(self)
 ColorPickerFrame:ClearAllPoints()
 ColorPickerFrame:SetPoint("TOP", UIParent)
 self.r, self.g, self.b = unpack(hudoptions[hudpro].target[6])
 OpenColorPicker(self)
 end)
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:EnableMouse(true)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].target[7] then
		hudoptions[hudpro].target[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].target[7] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 target.frame[fi].string = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi].string:SetPoint("TOPLEFT", 10, -220)
 target.frame[fi].string:SetText("class color")
 target.frame[fi].string:SetAlpha(hudoptions[hudpro].target[7] and 1 or 0.3)
 target.frame[fi]:SetAllPoints(target.frame[fi].string)
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:EnableMouse(true)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].target[8] then
		hudoptions[hudpro].target[8] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].target[8] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 target.frame[fi].string = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi].string:SetPoint("TOPLEFT", 10, -240)
 target.frame[fi].string:SetText("power color")
 target.frame[fi].string:SetAlpha(hudoptions[hudpro].target[8] and 1 or 0.3)
 target.frame[fi]:SetAllPoints(target.frame[fi].string)
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:EnableMouse(true)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].target[9] then
		hudoptions[hudpro].target[9] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].target[9] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 target.frame[fi].string = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi].string:SetPoint("TOPLEFT", 0, -270)
 target.frame[fi].string:SetText("health text")
 target.frame[fi].string:SetAlpha(hudoptions[hudpro].target[9] and 1 or 0.3)
 target.frame[fi]:SetAllPoints(target.frame[fi].string)
 fi=fi+1
 target.frame[fi] = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi]:SetPoint("TOPLEFT", 10, -300)
 target.frame[fi]:SetText("style:")
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame", "hudtargetdd", target.frame, "UIDropDownMenuTemplate")
 target.frame[fi]:SetPoint("LEFT", target.frame[fi-1], "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(target.frame[fi], function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = textList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(hudtargetdd, textList[i]) hudoptions[hudpro].target[10] = option[i].value updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(target.frame[fi], textList[hudoptions[hudpro].target[10]])
 fi=fi+1
 target.frame[fi] = CreateFrame("Frame",nil,target.frame)
 target.frame[fi]:EnableMouse(true)
 target.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].target[11] then
		hudoptions[hudpro].target[11] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].target[11] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 target.frame[fi].string = target.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 target.frame[fi].string:SetPoint("TOPLEFT", 10, -330)
 target.frame[fi].string:SetText("hide when full")
 target.frame[fi].string:SetAlpha(hudoptions[hudpro].target[11] and 1 or 0.3)
 target.frame[fi]:SetAllPoints(target.frame[fi].string)

end
 
 local rightblock = CreateFrame("Button", nil, hudconfigframe)
 rightblock:SetText("right block");
 rightblock:SetPoint("CENTER", 70, 70)
 rightblock:SetNormalFontObject(GameFontHighlight)
 rightblock:SetWidth(60)
 rightblock:SetHeight(15)
 rightblock:SetAlpha(0.5)
 rightblock:SetScript("OnMouseUp", clickbut)
 rightblock.frame = CreateFrame("Frame",nil,hudconfigframe)
 rightblock.frame:SetPoint("LEFT", 20, 0)
 rightblock.frame:SetWidth(300)
 rightblock.frame:SetHeight(500)
 rightblock.frame:Hide()

do -- powerbar config
  
 local power = CreateFrame("Button", nil, hudconfigframe)
 power:SetText("power bar");
 power:SetPoint("CENTER", 150, -120)
 power:SetNormalFontObject(GameFontHighlight)
 power:SetWidth(60)
 power:SetHeight(15)
 power:SetAlpha(0.5)
 power:SetScript("OnMouseUp", clickbut)
 power.frame = CreateFrame("Frame",nil,hudconfigframe)
 power.frame:SetPoint("LEFT", 20, 0)
 power.frame:SetWidth(300)
 power.frame:SetHeight(500)
 power.frame:Hide()
 power.frame.elem1 = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem1:SetPoint("TOPLEFT")
 power.frame.elem1:SetText("power bar")
 power.frame.elem2 = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem2:SetPoint("TOPLEFT", 10, -30)
 power.frame.elem2:SetText("alpha:")
 power.frame.elem3 = CreateFrame("Slider", "powerframeelem3", power.frame, "OptionsSliderTemplate")
 power.frame.elem3:SetPoint("TOPLEFT", 10, -43)
 power.frame.elem3:SetWidth(100)
 power.frame.elem3:SetMinMaxValues(0, 20)
 power.frame.elem3:SetValue(hudoptions[hudpro].power[1]*20)
 powerframeelem3High:SetText(1)
 powerframeelem3Low:SetText(0)
 powerframeelem3Text:SetText(hudoptions[hudpro].power[1])
 power.frame.elem3:SetValueStep(1)
 power.frame.elem3:SetScript("OnMouseUp", function(self)
	self:SetScript("OnUpdate", nil)
	temp = (self:GetValue()/20)
	hudoptions[hudpro].power[1] = temp
	updateHud()
 end)
 power.frame.elem3:SetScript("OnMouseDown", function(self)
	self:SetScript("OnUpdate", function()
		powerframeelem3Text:SetText(self:GetValue()/20)
	end)	
 end)
 power.frame.elem4 = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem4:SetPoint("TOPLEFT", 10, -70)
 power.frame.elem4:SetText("color:")
 power.frame.elem5 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem5:SetPoint("LEFT", power.frame.elem4, "RIGHT", 10, -1)
 power.frame.elem5:SetWidth(10)
 power.frame.elem5:SetHeight(10)
 powerglob1 = power.frame.elem5:CreateTexture(nil)
 powerglob1:SetAllPoints()
 powerglob1:SetTexture(unpack(hudoptions[hudpro].power[2]))
 power.frame.elem5:EnableMouse(true)
 power.frame.elem5.swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].power[2][1] = r
	hudoptions[hudpro].power[2][2] = g
	hudoptions[hudpro].power[2][3] = b
	powerglob1:SetTexture(r, g, b)
	updateHud()
 end
 power.frame.elem5:SetScript("OnMouseUp", function(self)
 ColorPickerFrame:ClearAllPoints()
 ColorPickerFrame:SetPoint("TOP", UIParent)
 self.r, self.g, self.b = unpack(hudoptions[hudpro].power[2])
 OpenColorPicker(self)
 end)
 power.frame.elem6 = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem6:SetPoint("TOPLEFT", 10, -90)
 power.frame.elem6:SetText("OnShow")
 power.frame.elem7 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem7:EnableMouse(true)
 power.frame.elem7:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[3] then
		hudoptions[hudpro].power[3] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[3] = true
		self.string:SetAlpha(1)
	end
 end)
 power.frame.elem7.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem7.string:SetPoint("TOPLEFT", 20, -110)
 power.frame.elem7.string:SetText("scale")
 power.frame.elem7.string:SetAlpha(hudoptions[hudpro].power[3] and 1 or 0.3)
 power.frame.elem7:SetAllPoints(power.frame.elem7.string)
 power.frame.elem8 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem8:EnableMouse(true)
 power.frame.elem8:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[4] then
		hudoptions[hudpro].power[4] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[4] = true
		self.string:SetAlpha(1)
	end
 end)
 power.frame.elem8.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem8.string:SetPoint("TOPLEFT", 20, -130)
 power.frame.elem8.string:SetText("rotate")
 power.frame.elem8.string:SetAlpha(hudoptions[hudpro].power[4] and 1 or 0.3)
 power.frame.elem8:SetAllPoints(power.frame.elem8.string)
 power.frame.elem9 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem9:EnableMouse(true)
 power.frame.elem9:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[5] then
		hudoptions[hudpro].power[5] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[5] = true
		self.string:SetAlpha(1)
	end
 end)
 power.frame.elem9.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem9.string:SetPoint("TOPLEFT", 20, -150)
 power.frame.elem9.string:SetText("fade")
 power.frame.elem9.string:SetAlpha(hudoptions[hudpro].power[5] and 1 or 0.3)
 power.frame.elem9:SetAllPoints(power.frame.elem9.string)
 
 power.frame.elem10 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem10:EnableMouse(true)
 power.frame.elem10:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[6] then
		hudoptions[hudpro].power[6] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[6] = true
		self.string:SetAlpha(1)
	end
 end)
 power.frame.elem10.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem10.string:SetPoint("TOPLEFT", 20, -200)
 power.frame.elem10.string:SetText("scale")
 power.frame.elem10.string:SetAlpha(hudoptions[hudpro].power[6] and 1 or 0.3)
 power.frame.elem10:SetAllPoints(power.frame.elem10.string)
 power.frame.elem11 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem11:EnableMouse(true)
 power.frame.elem11:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[7] then
		hudoptions[hudpro].power[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[7] = true
		self.string:SetAlpha(1)
	end
 end)
 power.frame.elem11.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem11.string:SetPoint("TOPLEFT", 20, -220)
 power.frame.elem11.string:SetText("rotate")
 power.frame.elem11.string:SetAlpha(hudoptions[hudpro].power[7] and 1 or 0.3)
 power.frame.elem11:SetAllPoints(power.frame.elem11.string)
 power.frame.elem12 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem12:EnableMouse(true)
 power.frame.elem12:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[8] then
		hudoptions[hudpro].power[8] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[8] = true
		self.string:SetAlpha(1)
	end
 end)
 power.frame.elem12.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem12.string:SetPoint("TOPLEFT", 20, -240)
 power.frame.elem12.string:SetText("fade")
 power.frame.elem12.string:SetAlpha(hudoptions[hudpro].power[8] and 1 or 0.3)
 power.frame.elem12:SetAllPoints(power.frame.elem12.string)
 power.frame.elem13 = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem13:SetPoint("TOPLEFT", 10, -180)
 power.frame.elem13:SetText("OnHide")
 
 power.frame.elem14 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem14:EnableMouse(true)
 power.frame.elem14:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[9] then
		hudoptions[hudpro].power[9] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[9] = true
		self.string:SetAlpha(1)
	end
end)
 power.frame.elem14.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem14.string:SetPoint("TOPLEFT", 0, -270)
 power.frame.elem14.string:SetText("power text")
 power.frame.elem14.string:SetAlpha(hudoptions[hudpro].power[9] and 1 or 0.3)
 power.frame.elem14:SetAllPoints(power.frame.elem14.string)
 power.frame.elem15 = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem15:SetPoint("TOPLEFT", 10, -300)
 power.frame.elem15:SetText("style:")
 power.frame.elem16 = CreateFrame("Frame", "power.frame.elem16", power.frame, "UIDropDownMenuTemplate")
 power.frame.elem16:SetPoint("LEFT", power.frame.elem15, "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(power.frame.elem16, function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = textList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(power.frame.elem16, textList[i]) hudoptions[hudpro].power[10] = option[i].value updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(power.frame.elem16, textList[hudoptions[hudpro].power[10]])
 power.frame.elem17 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem17:EnableMouse(true)
 power.frame.elem17:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[11] then
		hudoptions[hudpro].power[11] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[11] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 power.frame.elem17.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem17.string:SetPoint("TOPLEFT", 10, -330)
 power.frame.elem17.string:SetText("hide when full")
 power.frame.elem17.string:SetAlpha(hudoptions[hudpro].power[11] and 1 or 0.3)
 power.frame.elem17:SetAllPoints(power.frame.elem17.string)
 
 power.frame.elem18 = CreateFrame("Frame",nil,power.frame)
 power.frame.elem18:EnableMouse(true)
 power.frame.elem18:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].power[12] then
		hudoptions[hudpro].power[12] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].power[12] = true
		self.string:SetAlpha(1)
	end
	updateHud()
end)
 power.frame.elem18.string = power.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 power.frame.elem18.string:SetPoint("TOPLEFT", 10, -350)
 power.frame.elem18.string:SetText("hide when empty")
 power.frame.elem18.string:SetAlpha(hudoptions[hudpro].power[12] and 1 or 0.3)
 power.frame.elem18:SetAllPoints(power.frame.elem18.string)

end


do -- right bar ( buffcheck ) 
 
  fi=1
 local rightbar = CreateFrame("Button", nil, hudconfigframe)
 rightbar:SetText("right bar");
 rightbar:SetPoint("CENTER", 200, 0)
 rightbar:SetNormalFontObject(GameFontHighlight)
 rightbar:SetWidth(60)
 rightbar:SetHeight(15)
 rightbar:SetAlpha(0.5)
 rightbar:SetScript("OnMouseUp", clickbut)
 rightbar.frame = CreateFrame("Frame",nil,hudconfigframe)
 rightbar.frame:SetPoint("LEFT", 20, 0)
 rightbar.frame:SetWidth(300)
 rightbar.frame:SetHeight(500)
 rightbar.frame:Hide()
 rightbar.frame[fi] = CreateFrame("Frame",nil,rightbar.frame)
 rightbar.frame[fi]:EnableMouse(true)
 rightbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].rightbar[1] then
		hudoptions[hudpro].rightbar[1] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].rightbar[1] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 rightbar.frame[fi].string = rightbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 rightbar.frame[fi].string:SetPoint("TOPLEFT")
 rightbar.frame[fi].string:SetText("Right bar")
 rightbar.frame[fi].string:SetAlpha(hudoptions[hudpro].rightbar[1] and 1 or 0.3)
 rightbar.frame[fi]:SetAllPoints(rightbar.frame[fi].string)
 fi=fi+1
 rightbar.frame[fi] = rightbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 rightbar.frame[fi]:SetPoint("TOPLEFT", 10, -30)
 rightbar.frame[fi]:SetText("buff/debuff:")
 fi=fi+1
 rightbar.frame[fi] = CreateFrame("EditBox", "rightbarframeelem3", rightbar.frame, "InputBoxTemplate")
 rightbar.frame[fi]:SetPoint("LEFT", rightbar.frame[fi-1], "RIGHT", 10, 0)
 rightbar.frame[fi]:SetAutoFocus(false)
 rightbar.frame[fi]:SetText(hudoptions[hudpro].rightbar[2])
 Dimension(rightbar.frame[fi], 120, 16)
 rightbar.frame[fi]:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].rightbar[2] = self:GetText()
	updateHud()
	self:ClearFocus()
 end)
 fi=fi+1
 rightbar.frame[fi] = rightbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 rightbar.frame[fi]:SetPoint("TOPLEFT", 10, -65)
 rightbar.frame[fi]:SetText("target:")
 fi=fi+1
 rightbar.frame[fi] = CreateFrame("Frame", "hudrightbarframedrop", rightbar.frame, "UIDropDownMenuTemplate")
 rightbar.frame[fi]:SetPoint("LEFT", rightbar.frame[fi-1], "RIGHT", -15, 0)
 UIDropDownMenu_Initialize(rightbar.frame[fi], function()
	local option = {}
	for i=1, 5 do
		
		option[i] = {}
		option[i].text = tarList[i]
		option[i].value = i
		option[i].func = function() UIDropDownMenu_SetText(hudrightbarframedrop, tarList[i]) hudoptions[hudpro].rightbar[3] = tarList[i] updateHud() end
		UIDropDownMenu_AddButton(option[i])
   end
 end)
 UIDropDownMenu_SetText(rightbar.frame[fi], hudoptions[hudpro].rightbar[3])
 fi=fi+1
 rightbar.frame[fi] = rightbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 rightbar.frame[fi]:SetPoint("TOPLEFT", 10, -90)
 rightbar.frame[fi]:SetText("color:")
 fi=fi+1
 rightbar.frame[fi] = CreateFrame("Frame",nil,rightbar.frame)
 rightbar.frame[fi]:SetPoint("LEFT", rightbar.frame[fi-1], "RIGHT", 10, -1)
 rightbar.frame[fi]:SetWidth(10)
 rightbar.frame[fi]:SetHeight(10)
 rightbarglob1 = rightbar.frame[fi]:CreateTexture(nil)
 rightbarglob1:SetAllPoints()
 rightbarglob1:SetTexture(unpack(hudoptions[hudpro].rightbar[4]))
 rightbar.frame[fi]:EnableMouse(true)
 rightbar.frame[fi].swatchFunc = function()
	local r, g, b = ColorPickerFrame:GetColorRGB()	
	hudoptions[hudpro].rightbar[4][1] = r
	hudoptions[hudpro].rightbar[4][2] = g
	hudoptions[hudpro].rightbar[4][3] = b
	rightbarglob1:SetTexture(r, g, b)
	updateHud()
 end
 rightbar.frame[fi].hasOpacity = 1
 rightbar.frame[fi].opacityFunc = function()
	hudoptions[hudpro].rightbar[5] = 1 - OpacitySliderFrame:GetValue()
	updateHud()
 end
 rightbar.frame[fi]:SetScript("OnMouseUp", function(self)
 self.opacity = 1 - hudoptions[hudpro].rightbar[5]
 self.r, self.g, self.b = unpack(hudoptions[hudpro].rightbar[4])
 OpenColorPicker(self)
 end)
 fi=fi+1
 rightbar.frame[fi] = CreateFrame("Frame",nil,rightbar.frame)
 rightbar.frame[fi]:EnableMouse(true)
 rightbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].rightbar[6] then
		hudoptions[hudpro].rightbar[6] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].rightbar[6] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 rightbar.frame[fi].string = rightbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 rightbar.frame[fi].string:SetPoint("TOPLEFT", 20, -110)
 rightbar.frame[fi].string:SetText("invert")
 rightbar.frame[fi].string:SetAlpha(hudoptions[hudpro].rightbar[6] and 1 or 0.3)
 rightbar.frame[fi]:SetAllPoints(rightbar.frame[fi].string)
 fi=fi+1
 rightbar.frame[fi] = CreateFrame("Frame",nil,rightbar.frame)
 rightbar.frame[fi]:EnableMouse(true)
 rightbar.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].rightbar[7] then
		hudoptions[hudpro].rightbar[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].rightbar[7] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 rightbar.frame[fi].string = rightbar.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 rightbar.frame[fi].string:SetPoint("TOPLEFT", 20, -130)
 rightbar.frame[fi].string:SetText("by player only")
 rightbar.frame[fi].string:SetAlpha(hudoptions[hudpro].rightbar[7] and 1 or 0.3)
 rightbar.frame[fi]:SetAllPoints(rightbar.frame[fi].string)
 
end
 
do --cp/runes+
 
 local extrablocks = CreateFrame("Button", nil, hudconfigframe)
 extrablocks:SetText("extra blocks");
 extrablocks:SetPoint("CENTER", 190, -65)
 extrablocks:SetNormalFontObject(GameFontHighlight)
 extrablocks:SetWidth(60)
 extrablocks:SetHeight(15)
 extrablocks:SetAlpha(0.5)
 extrablocks:SetScript("OnMouseUp", clickbut)
 extrablocks.frame = CreateFrame("Frame",nil,hudconfigframe)
 extrablocks.frame:SetPoint("LEFT", 20, 0)
 extrablocks.frame:SetWidth(300)
 extrablocks.frame:SetHeight(500)
 extrablocks.frame:Hide()
 extrablocks.frame1 = CreateFrame("Frame",nil,extrablocks.frame)
 extrablocks.frame1:SetAllPoints()
 extrablocks:SetScript("OnMouseUp", clickbut)
 extrablocks.frame2 = CreateFrame("Frame",nil,extrablocks.frame)
 extrablocks.frame2:SetAllPoints()
 extrablocks.tab1 = CreateFrame("Frame",nil,extrablocks.frame)
 extrablocks.tab1:EnableMouse(true)
 extrablocks.tab1:SetScript("OnMouseUp", function(self)
		self.string:SetAlpha(1)
		extrablocks.tab2.string:SetAlpha(0.3)
		extrablocks.frame1:Show()
		extrablocks.frame2:Hide()
 end)
 extrablocks.tab1.string = extrablocks.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 extrablocks.tab1.string:SetPoint("TOPLEFT", extrablocks.frame1)
 extrablocks.tab1.string:SetText("runes")
 extrablocks.tab1.string:SetAlpha(0.3)
 extrablocks.tab1:SetAllPoints(extrablocks.tab1.string)
 extrablocks.tab2 = CreateFrame("Frame",nil,extrablocks.frame)
 extrablocks.tab2:EnableMouse(true)
 extrablocks.tab2:SetScript("OnMouseUp", function(self)
		self.string:SetAlpha(1)
		extrablocks.tab1.string:SetAlpha(0.3)
		extrablocks.frame2:Show()
		extrablocks.frame1:Hide()
 end)
 extrablocks.tab2.string = extrablocks.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 extrablocks.tab2.string:SetPoint("LEFT", extrablocks.tab1.string, "RIGHT", 10, 0)
 extrablocks.tab2.string:SetText("combo points")
 extrablocks.tab2.string:SetAlpha(0.3)
 extrablocks.tab2:SetAllPoints(extrablocks.tab2.string)
 if select(2, UnitClass("player")) == "DEATHKNIGHT" then
	extrablocks.frame2:Hide()
	extrablocks.tab1.string:SetAlpha(1)
 else
	extrablocks.frame1:Hide()
	extrablocks.tab2.string:SetAlpha(1)
 end
 
end

do --general options

local general = CreateFrame("Button", nil, hudconfigframe)
 general:SetNormalFontObject(GameFontHighlightRight)
 general:SetText("general")
 general:SetPoint("RIGHT", -20, 100)
 general:SetWidth(60)
 general:SetHeight(15)
 general:SetAlpha(0.5)
 general:SetScript("OnMouseUp", clickbut)
 general.frame = CreateFrame("Frame",nil,hudconfigframe)
 general.frame:SetPoint("LEFT", 20, 0)
 general.frame:SetWidth(300)
 general.frame:SetHeight(500)
 general.frame:Hide()
 fi=1
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("TOPLEFT")
 general.frame[fi]:SetText("General Settings")
 fi=fi+1
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("TOPLEFT", 10, -30)
 general.frame[fi]:SetText("scale:")
 fi=fi+1
 general.frame[fi] = CreateFrame("EditBox", "generalframeelem3", general.frame, "InputBoxTemplate")
 general.frame[fi]:SetPoint("LEFT", general.frame[fi-1], "RIGHT", 10, 0)
 general.frame[fi]:SetAutoFocus(false)
 general.frame[fi]:SetText(hudoptions[hudpro].general[1])
 Dimension(general.frame[fi], 30, 16)
 general.frame[fi]:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].general[1] = tonumber(self:GetText())
	updateHud()
	self:ClearFocus()
 end)
 fi=fi+1
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("TOPLEFT", 10, -50)
 general.frame[fi]:SetText("alpha:")
 fi=fi+1
 general.frame[fi] = CreateFrame("Slider", "generalframeelem5", general.frame, "OptionsSliderTemplate")
 general.frame[fi]:SetPoint("TOPLEFT", 10, -63)
 general.frame[fi]:SetWidth(100)
 general.frame[fi]:SetMinMaxValues(0, 20)
 general.frame[fi]:SetValue(hudoptions[hudpro].general[2]*20)
 generalframeelem5High:SetText(1)
 generalframeelem5Low:SetText(0)
 generalframeelem5Text:SetText(hudoptions[hudpro].general[2])
 general.frame[fi]:SetValueStep(1)
 general.frame[fi]:SetScript("OnMouseUp", function(self)
	self:SetScript("OnUpdate", nil)
	temp = (self:GetValue()/20)
	hudoptions[hudpro].general[2] = temp
	updateHud()
 end)
 general.frame[fi]:SetScript("OnMouseDown", function(self)
	self:SetScript("OnUpdate", function()
		generalframeelem5Text:SetText(self:GetValue()/20)
	end)	
 end)
 fi=fi+1
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("TOPLEFT", 10, -90)
 general.frame[fi]:SetText("offsets")
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("TOPLEFT", 10, -110)
 general.frame[fi]:SetText("x:")
 fi=fi+1
 general.frame[fi] = CreateFrame("EditBox", "generalframeelem8", general.frame, "InputBoxTemplate")
 general.frame[fi]:SetPoint("LEFT", general.frame[fi-1], "RIGHT", 10, 0)
 general.frame[fi]:SetAutoFocus(false)
 general.frame[fi]:SetText(hudoptions[hudpro].general[3])
 Dimension(general.frame[fi], 30, 16)
 general.frame[fi]:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].general[3] = tonumber(self:GetText())
	updateHud()
	self:ClearFocus()
 end)
 fi=fi+1
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("LEFT", general.frame[fi-1], "RIGHT", 10, 0)
 general.frame[fi]:SetText("y:")
 fi=fi+1
 general.frame[fi] = CreateFrame("EditBox", "generalframeelem10", general.frame, "InputBoxTemplate")
 general.frame[fi]:SetPoint("LEFT", general.frame[fi-1], "RIGHT", 10, 0)
 general.frame[fi]:SetAutoFocus(false)
 general.frame[fi]:SetText(hudoptions[hudpro].general[4])
 Dimension(general.frame[fi], 30, 16)
 general.frame[fi]:SetScript("OnEnterPressed", function(self)
	hudoptions[hudpro].general[4] = tonumber(self:GetText())
	updateHud()
	self:ClearFocus()
 end)
 fi=fi+1
 general.frame[fi] = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi]:SetPoint("TOPLEFT", 10, -140)
 general.frame[fi]:SetText("Fade out when:")
 fi=fi+1
 general.frame[fi] = CreateFrame("Frame",nil,general.frame)
 general.frame[fi]:EnableMouse(true)
 general.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].general[5] then
		hudoptions[hudpro].general[5] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].general[5] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 general.frame[fi].string = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi].string:SetPoint("TOPLEFT", 20, -160)
 general.frame[fi].string:SetText("full health")
 general.frame[fi].string:SetAlpha(hudoptions[hudpro].general[5] and 1 or 0.3)
 general.frame[fi]:SetAllPoints(general.frame[fi].string)
 fi=fi+1
 general.frame[fi] = CreateFrame("Frame",nil,general.frame)
 general.frame[fi]:EnableMouse(true)
 general.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].general[6] then
		hudoptions[hudpro].general[6] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].general[6] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 general.frame[fi].string = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi].string:SetPoint("TOPLEFT", 20, -180)
 general.frame[fi].string:SetText("full power")
 general.frame[fi].string:SetAlpha(hudoptions[hudpro].general[6] and 1 or 0.3)
 general.frame[fi]:SetAllPoints(general.frame[fi].string)
 fi=fi+1
 general.frame[fi] = CreateFrame("Frame",nil,general.frame)
 general.frame[fi]:EnableMouse(true)
 general.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].general[7] then
		hudoptions[hudpro].general[7] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].general[7] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 general.frame[fi].string = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi].string:SetPoint("TOPLEFT", 20, -200)
 general.frame[fi].string:SetText("no power")
 general.frame[fi].string:SetAlpha(hudoptions[hudpro].general[7] and 1 or 0.3)
 general.frame[fi]:SetAllPoints(general.frame[fi].string)
 fi=fi+1
 general.frame[fi] = CreateFrame("Frame",nil,general.frame)
 general.frame[fi]:EnableMouse(true)
 general.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].general[8] then
		hudoptions[hudpro].general[8] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].general[8] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 general.frame[fi].string = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi].string:SetPoint("TOPLEFT", 20, -220)
 general.frame[fi].string:SetText("no combat")
 general.frame[fi].string:SetAlpha(hudoptions[hudpro].general[8] and 1 or 0.3)
 general.frame[fi]:SetAllPoints(general.frame[fi].string)
 fi=fi+1
 general.frame[fi] = CreateFrame("Frame",nil,general.frame)
 general.frame[fi]:EnableMouse(true)
 general.frame[fi]:SetScript("OnMouseUp", function(self)
	if hudoptions[hudpro].general[9] then
		hudoptions[hudpro].general[9] = false
		self.string:SetAlpha(0.3)
	else
		hudoptions[hudpro].general[9] = true
		self.string:SetAlpha(1)
	end
	updateHud()
 end)
 general.frame[fi].string = general.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 general.frame[fi].string:SetPoint("TOPLEFT", 20, -240)
 general.frame[fi].string:SetText("no target")
 general.frame[fi].string:SetAlpha(hudoptions[hudpro].general[9] and 1 or 0.3)
 general.frame[fi]:SetAllPoints(general.frame[fi].string)
 --fi=fi+1
 
end
 
do --profile options
local selpro=""
local profile = CreateFrame("Button", nil, hudconfigframe)
 profile:SetNormalFontObject(GameFontHighlightRight)
 profile:SetText("profiles")
 profile:SetPoint("RIGHT", -20, 85)
 profile:SetWidth(60)
 profile:SetHeight(15)
 profile:SetAlpha(0.5)
 profile:SetScript("OnMouseUp", clickbut)
 profile.frame = CreateFrame("Frame",nil,hudconfigframe)
 profile.frame:SetPoint("LEFT", 20, 0)
 profile.frame:SetWidth(300)
 profile.frame:SetHeight(500)
 profile.frame:Hide()
 fi=1
 profile.frame[fi] = profile.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
 profile.frame[fi]:SetPoint("TOPLEFT")
 profile.frame[fi]:SetText("profiles")
 fi=fi+1
 profile.frame[fi] = CreateFrame("EditBox", "hudprofileeditbox", profile.frame, "InputBoxTemplate")
 profile.frame[fi]:SetPoint("TOPLEFT", 10, -35)
 profile.frame[fi]:SetAutoFocus(false)
 profile.frame[fi]:SetText("loldisistext")
 Dimension(profile.frame[fi], 120, 16)
 profile.frame[fi]:SetScript("OnEnterPressed", function(self)
	self:ClearFocus()
 end)
 fi=fi+1
 profile.frame[fi] = CreateFrame("Button", nil, profile.frame)
 profile.frame[fi]:SetNormalFontObject(GameFontHighlightLeft)
 profile.frame[fi]:SetText("load")
 profile.frame[fi]:SetPoint("TOPLEFT", 10, -15)
 profile.frame[fi]:SetWidth(30)
 profile.frame[fi]:SetHeight(15)
 --profile.frame[fi]:SetAlpha(0.5)
 profile.frame[fi]:SetScript("OnMouseUp", function()
	hudpro = selpro
	updhudpro()
	updateHud() 
 end)
 fi=fi+1
 profile.frame[fi] = CreateFrame("Button", nil, profile.frame)
 profile.frame[fi]:SetNormalFontObject(GameFontHighlightLeft)
 profile.frame[fi]:SetText("new")
 profile.frame[fi]:SetPoint("LEFT",profile.frame[fi-1], "RIGHT", 0, 0)
 profile.frame[fi]:SetWidth(30)
 profile.frame[fi]:SetHeight(15)
 --profile.frame[fi]:SetAlpha(0.5)
 profile.frame[fi]:SetScript("OnMouseUp", function()
	hudoptions[hudprofileeditbox:GetText()] = hudwipetable["default"]
	updhudpro()
 end)
 fi=fi+1
 profile.frame[fi] = CreateFrame("Button", nil, profile.frame)
 profile.frame[fi]:SetNormalFontObject(GameFontHighlightLeft)
 profile.frame[fi]:SetText("delete")
 profile.frame[fi]:SetPoint("LEFT",profile.frame[fi-1], "RIGHT", 0, 0)
 profile.frame[fi]:SetWidth(40)
 profile.frame[fi]:SetHeight(15)
 --profile.frame[fi]:SetAlpha(0.5)
 profile.frame[fi]:SetScript("OnMouseUp", function()
	hudoptions[selpro] = nil
	updhudpro()
 end)
 fi=fi+1
 profile.frame[fi] = CreateFrame("Button", nil, profile.frame)
 profile.frame[fi]:SetNormalFontObject(GameFontHighlightLeft)
 profile.frame[fi]:SetText("copy")
 profile.frame[fi]:SetPoint("LEFT",profile.frame[fi-1], "RIGHT", 0, 0)
 profile.frame[fi]:SetWidth(30)
 profile.frame[fi]:SetHeight(15)
 --profile.frame[fi]:SetAlpha(0.5)
 profile.frame[fi]:SetScript("OnMouseUp", function()
	hudoptions[hudprofileeditbox:GetText()] = hudoptions[selpro]
	print(selpro)
	updhudpro()
 end)
 fi=fi+1
 
 profile.frame[fi] = {}
 for i=1, 15 do
	profile.frame[fi][i] = CreateFrame("Frame",nil,profile.frame)
	profile.frame[fi][i]:EnableMouse(true)
	profile.frame[fi][i]:SetScript("OnMouseUp", function(self)
		selpro = self.string:GetText():gsub(">", "")
		updhudpro()
	end)
	profile.frame[fi][i].string = profile.frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLeft")
	profile.frame[fi][i].string:SetPoint("TOPLEFT", 10, -50-i*15)
	profile.frame[fi][i].string:SetText("invert")
	profile.frame[fi][i].string:SetAlpha(i==4 and 1 or 0.3)
	profile.frame[fi][i]:SetAllPoints(profile.frame[fi][i].string)
 end
 function updhudpro()
	local i=1
	for name, frame in pairs(hudoptions) do
		if name==hudpro then
			profile.frame[7][i].string:SetText(">"..name)
		else
			profile.frame[7][i].string:SetText(name)
		end
		profile.frame[7][i]:Show()
		profile.frame[7][i].string:Show()
		if name==(selpro:gsub(">", "")) then
			profile.frame[7][i].string:SetAlpha(1)
		else
			profile.frame[7][i].string:SetAlpha(0.3)
		end
		i=i+1
	end
	for i=i, 15 do
		profile.frame[7][i]:Hide()
		profile.frame[7][i].string:Hide()
	end
 end
 updhudpro()
 fi=fi+1

 end
 




